//
//  fooAppDelegate.m
//  foo
//
//  Created by James Koning on 3/29/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "fooAppDelegate.h"
#import "MyView.h"
#import "fooThread.h"

@implementation fooAppDelegate

@synthesize window;
@synthesize contentView;
@synthesize queue;
@synthesize execThread;

- (void)applicationDidFinishLaunching:(UIApplication *)application 
{
	// Create window
	self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    
    // Set up content view
	self.contentView = [[[MyView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]] autorelease];
	[window addSubview:contentView];
    
	// Show window
	[window makeKeyAndVisible];

    // construct the thread
	self.execThread = [[fooThread alloc] init];

    // set the thread's view (updateDisplay handler) object
    self.execThread.contentView = self.contentView;
		
	//self.contentView.emu = self.execThread;

    // init the queue
    self.queue = [[NSOperationQueue alloc] init];
    [self.queue setMaxConcurrentOperationCount:2];

    // run the thread
	[self.queue addOperation:execThread];
}

-(void)applicationWillTerminate:(UIApplication *)application
 {
    [self.queue cancelAllOperations];
    [self.queue waitUntilAllOperationsAreFinished];
	
 }
 
 - (void)dealloc {
	[contentView release];
	[window release];
	[execThread release];
	[queue release];
	[super dealloc];
}

@end
